#!/usr/bin/perl -I/usr/sausalito/perl

# $id:$ 

use CCE;
use Sauce::Util;
use strict;

my $portForwardRulesFile = "/etc/portfw.conf";

my $cce = new CCE();
$cce->connectfd(\*STDIN, \*STDOUT);

my $data; my $ok;
$data = "ipmasqadm portfw -f\n";

# get the network object for devicename to ipaddr translation
my @networkOids = $cce->find("Network");
my $networks = {};
for my $networkOid (@networkOids) {
	my ($ok, $network) = $cce->get($networkOid);
	$networks->{$network->{device}} = $network;
}

my @oids = $cce->find("PortForward");
for my $oid (@oids) {
	my ($ok, $obj) = $cce->get($oid);
	#grab the ip
	my $ipaddr = $networks->{$obj->{sourceIP}}->{ipaddr};
	#write the line
	$data .= "ipmasqadm portfw -a -P " . lc ($obj->{protocol}) . " -L " . $ipaddr . " " . $obj->{sourcePort} . " -R " . $obj->{targetIP} . " " . $obj->{targetPort} . "\n";
}

system("touch $portForwardRulesFile 2> /dev/null");
system("chmod 0700 $portForwardRulesFile");

Sauce::Util::editfile( $portForwardRulesFile, \&writeConfig, $data);

system("/etc/rc.d/init.d/portfw restart 2> /dev/null");

$cce->bye("SUCCESS");
1;

sub writeConfig {
	my $fin = shift;
	my $fout = shift;
	my $data = shift;
	print $fout ($data);
}
